customhud.uiconfig={}
customhud.uiconfig.dialog={}

customhud.uiconfig.version = iup.label { title = 'v'..customhud.vars.version }

customhud.uiconfig.fontsizetext = iup.text { value = customhud.vars.fontsize, size = '40x' }
customhud.uiconfig.refreshtext = iup.text { value = customhud.vars.refreshdelay, size = '40x' }
customhud.uiconfig.precisiontext = iup.text { value = customhud.vars.precision, size = '40x' }

customhud.uiconfig.shipinfobuttondefault = iup.stationbutton { title = 'Default' }
customhud.uiconfig.shipinfobuttonposition = iup.stationbutton { title = 'Custom position' }
customhud.uiconfig.targetinfobuttondefault = iup.stationbutton { title = 'Default' }
customhud.uiconfig.targetinfobuttonposition = iup.stationbutton { title = 'Custom position' }
customhud.uiconfig.weaponinfobuttondefault = iup.stationbutton { title = 'Default' }
customhud.uiconfig.weaponinfobuttonposition = iup.stationbutton { title = 'Custom position' }

customhud.uiconfig.shiphealthtoggle = iup.stationtoggle { title = "Show dialog", value = customhud.vars.visibility.shiphealth,  fgcolor = "200 200 200" }
customhud.uiconfig.shiphealthlabeltoggle = iup.stationtoggle { title = "Show label", value = customhud.vars.visibility.shiphealthlabel,  fgcolor = "200 200 200" }

customhud.uiconfig.targetnametoggle = iup.stationtoggle { title = 'Show target name', value = customhud.vars.visibility.targetname, fgcolor = "200 200 200" }
customhud.uiconfig.targethealthtoggle = iup.stationtoggle { title = 'Show target health', value = customhud.vars.visibility.targethealth, fgcolor = "200 200 200" }
customhud.uiconfig.targetdistancetoggle = iup.stationtoggle { title = 'Show target distance', value = customhud.vars.visibility.targetdistance, fgcolor = "200 200 200" }
customhud.uiconfig.targetshiptoggle = iup.stationtoggle { title = 'Show target ship', value = customhud.vars.visibility.targetship, fgcolor = "200 200 200" }

customhud.uiconfig.weaponnamestoggle = iup.stationtoggle { title = 'Show weapon names', value = customhud.vars.visibility.weaponnames, fgcolor = "200 200 200" }
customhud.uiconfig.weaponammotoggle = iup.stationtoggle { title = 'Show dialog', value = customhud.vars.visibility.weaponammo, fgcolor = "200 200 200" }

customhud.uiconfig.list={}

function customhud.uiconfig.newalignmentlist(name)
	local function defaultvalue()
		if customhud.vars.alignment[name]=='ALEFT' then return 1
		elseif customhud.vars.alignment[name]=='ACENTER' then return 2
		elseif customhud.vars.alignment[name]=='ARIGHT' then return 3
		end
	end
	customhud.uiconfig.list[name] = iup.list { 'Left', 'Center', 'Right', dropdown='YES', value=defaultvalue() }
	
	local func=customhud.uiconfig.list[name]
	
	function func:action(text,number,value)
		if value==1 then
			customhud.vars.alignment[name]=string.upper('A'..text)
			customhud.restart()
		end
	end
	
	local iupbox = iup.hbox {
		iup.label { title = 'Alignment:' , expand='HORIZONTAL'},
		customhud.uiconfig.list[name],
	}
	return iupbox
end

customhud.uiconfig.okbutton = iup.stationbutton { title = "OK" }
customhud.uiconfig.cancelbutton = iup.stationbutton { title = "Cancel" }

customhud.uiconfig.togglehudbutton = iup.stationbutton { title = 'togglehud config' }

customhud.uiconfig.reopenconfig=false

customhud.uiconfig.main = iup.pdarootframe {
	iup.pdasubframebg {
		iup.vbox {
			iup.hbox {
				iup.label { title='customHUD config:', expand='HORIZONTAL' },
				iup.fill { size = '20' },
				customhud.uiconfig.version,
			},
			
			iup.fill { size = '20' },
			
			iup.hbox {
				margin='10x',
				iup.label { title = 'Font Size:', expand = 'HORIZONTAL'},
				iup.fill{},
				customhud.uiconfig.fontsizetext,
			},
			
			iup.hbox {
				margin='10x',
				iup.label { title = 'Refresh delay (miliseconds):', expand = 'HORIZONTAL' },
				iup.fill{ size = '5' },
				customhud.uiconfig.refreshtext,

			},
			
			iup.hbox {
				margin='10x',
				iup.label { title = 'Precision (number of decimal places):', expand = 'HORIZONTAL'},
				iup.fill{},
				customhud.uiconfig.precisiontext,
			},
			
			iup.hbox{
				margin='10x',
				iup.label { title = 'Ship health dialog:', expand = 'HORIZONTAL' },
			},
			
			iup.vbox {
				margin='20x',
				
				customhud.uiconfig.shiphealthtoggle,
				customhud.uiconfig.shiphealthlabeltoggle,
				
				customhud.uiconfig.newalignmentlist('shipinfo'),
				
				iup.hbox {
					iup.label { title = 'Position:' , expand = 'HORIZONTAL' },
					iup.fill{ size = '10' },
					customhud.uiconfig.shipinfobuttondefault,
					customhud.uiconfig.shipinfobuttonposition,
				},
				
			},
			
			iup.hbox{
				margin='10x',
				iup.label { title = 'Target info dialog:', expand = 'HORIZONTAL' },
			},
			
			iup.vbox {
				margin = '20x',
				
				customhud.uiconfig.targetnametoggle,
				customhud.uiconfig.targethealthtoggle,
				customhud.uiconfig.targetdistancetoggle,
				customhud.uiconfig.targetshiptoggle,
				
				customhud.uiconfig.newalignmentlist('targetinfo'),
				
				iup.hbox {
					margin='10x',
					iup.label { title = 'Position:', expand = 'HORIZONTAL' },
					iup.fill{ size = '10' },
					customhud.uiconfig.targetinfobuttondefault,
					customhud.uiconfig.targetinfobuttonposition,
				},
			},
			
			iup.hbox{
				margin='10x',
				iup.label { title = 'Weapon info dialog:', expand = 'HORIZONTAL' },
			},
			
			iup.vbox {
				margin = '20x',
				
				customhud.uiconfig.weaponammotoggle,
				customhud.uiconfig.weaponnamestoggle,
				
				customhud.uiconfig.newalignmentlist('weaponinfo'),
								
				iup.hbox {
					margin='10x',
					iup.label { title = 'Position:', expand = 'HORIZONTAL' },
					iup.fill{ size = '10' },
					customhud.uiconfig.weaponinfobuttondefault,
					customhud.uiconfig.weaponinfobuttonposition,
				},
			},
			
			iup.hbox {
				margin='10x',
				
				iup.fill{},
			},
			
			iup.hbox {
				customhud.uiconfig.togglehudbutton,
				iup.fill{},
				customhud.uiconfig.okbutton,
				customhud.uiconfig.cancelbutton,
			},
		GAP='10'
		}
	}
}

customhud.uiconfig.dialog.main = iup.dialog {
	customhud.uiconfig.main,
	BORDER="NO",
    topmost = "YES",
    RESIZE="NO",
    MAXBOX="NO",
    MINBOX="NO",
    MENUBOX="NO",
    MODAL="YES",
	DEFAULTENTER=customhud.uiconfig.okbutton,
	DEFAULTESC=customhud.uiconfig.cancelbutton,
}

function customhud.uiconfig.okbutton:action()
	if tonumber(customhud.uiconfig.fontsizetext.value) then
		customhud.vars.fontsize=customhud.uiconfig.fontsizetext.value
		gkini.WriteString("customhud", "fontsize", customhud.uiconfig.fontsizetext.value)
		customhud.restart()
	end
	local refresh=tonumber(customhud.uiconfig.refreshtext.value)
	if refresh and refresh>0 then
		customhud.vars.refreshdelay=customhud.uiconfig.refreshtext.value
		gkini.WriteInt("customhud", "refreshdelay", customhud.uiconfig.refreshtext.value)
	end
	local precision=tonumber(customhud.uiconfig.precisiontext.value)
	if precision and precision>=0 and precision<10 then
		customhud.vars.precision = customhud.uiconfig.precisiontext.value
		gkini.WriteString("customhud", "precision", customhud.uiconfig.precisiontext.value)
	end
	
	for key,value in pairs(customhud.vars.alignment) do 
		gkini.WriteString('customhud', key..'alignment', value)
	end
	
	for key,value in pairs(customhud.vars.visibility) do
		gkini.WriteString('customhud', key, customhud.uiconfig[key..'toggle'].VALUE)
	end

	customhud.uiconfig.dialog.main:hide()
end

function customhud.uiconfig.cancelbutton:action()
	customhud.uiconfig.dialog.main:hide()
end

function customhud.uiconfig.togglehudbutton:action()
	customhud.uiconfig.dialog.togglehud:show()
end

function customhud.uiconfig.fontsizetext:action(c, after)
	after=tonumber(after)
	if after and after>0 then
	customhud.vars.fontsize=after
	customhud.restart()
	end
end

function customhud.uiconfig.refreshtext:action(c, after)
	after=tonumber(after)
	if after and after>0 then
	customhud.vars.refreshdelay=after
	end
end

function customhud.uiconfig.precisiontext:action(c, after)
	after=tonumber(after)
	if after and after>=0 and after<10 then
	customhud.vars.precision=after
	end
end

-- toggles' functions
function customhud.uiconfig.shiphealthtoggle:action(v)
	customhud.vars.visibility.shiphealth=customhud.uiconfig.shiphealthtoggle.VALUE
	customhud.restart()
end

function customhud.uiconfig.shiphealthlabeltoggle:action(v)
	customhud.vars.visibility.shiphealthlabel=customhud.uiconfig.shiphealthlabeltoggle.VALUE
	customhud.restart()
end

function customhud.uiconfig.targetnametoggle:action(v)
	customhud.vars.visibility.targetname=customhud.uiconfig.targetnametoggle.VALUE
	customhud.restart()
end

function customhud.uiconfig.targethealthtoggle:action(v)
	customhud.vars.visibility.targethealth=customhud.uiconfig.targethealthtoggle.VALUE
	customhud.restart()
end

function customhud.uiconfig.targetdistancetoggle:action(v)
	customhud.vars.visibility.targetdistance=customhud.uiconfig.targetdistancetoggle.VALUE
	customhud.restart()
end

function customhud.uiconfig.weaponammotoggle:action(v)
	customhud.vars.visibility.weaponammo=customhud.uiconfig.weaponammotoggle.VALUE
	customhud.restart()
end

function customhud.uiconfig.weaponnamestoggle:action(v)
	customhud.vars.visibility.weaponnames=customhud.uiconfig.weaponnamestoggle.VALUE
	customhud.restart()
end

function customhud.uiconfig.targetshiptoggle :action(v)
	customhud.vars.visibility.targetship=customhud.uiconfig.targetshiptoggle.VALUE
	customhud.restart()
end

				

-- end of toggles' functions

-- default position buttons functions
function customhud.uiconfig.shipinfobuttondefault:action()
	customhud.func.returntodefaultposition('shipinfo')
end

function customhud.uiconfig.targetinfobuttondefault:action()
	customhud.func.returntodefaultposition('targetinfo')
end

function customhud.uiconfig.weaponinfobuttondefault:action()
	customhud.func.returntodefaultposition('weaponinfo')
end
-- end of default position buttons

-- position buttons functions
function customhud.uiconfig.shipinfobuttonposition:action()
	customhud.SHOWpositiondialog('shipinfo')
	customhud.uiconfig.reopenconfig=true
	customhud.uiconfig.hide()
end

function customhud.uiconfig.targetinfobuttonposition:action()
	customhud.SHOWpositiondialog('targetinfo')
	customhud.uiconfig.reopenconfig=true
	customhud.uiconfig.hide()
end

function customhud.uiconfig.weaponinfobuttonposition:action()
	customhud.SHOWpositiondialog('weaponinfo')
	customhud.uiconfig.reopenconfig=true
	customhud.uiconfig.hide()
end
-- end of posiiton buttons functions

function customhud.uiconfig.show()
	if not PlayerInStation() then
	customhud.uiconfig.dialog.main:show()
	else
	print('Please undock first.')
	end
end

function customhud.uiconfig.hide()
	customhud.uiconfig.dialog.main:hide()
end



customhud.uiconfig.togglehud={}

customhud.uiconfig.togglehud.selfinfotoggle = iup.stationtoggle { title = 'Toggle selfinfo', value = customhud.vars.togglehud.visibility.selfinfo, fgcolor = "200 200 200"}
customhud.uiconfig.togglehud.chattoggle = iup.stationtoggle { title = 'Toggle chat', value = customhud.vars.togglehud.visibility.chat, fgcolor = "200 200 200"}
customhud.uiconfig.togglehud.missiontimerstoggle = iup.stationtoggle { title = 'Toggle missiontimers', value = customhud.vars.togglehud.visibility.missiontimers, fgcolor = "200 200 200"}
customhud.uiconfig.togglehud.licensetoggle = iup.stationtoggle { title = 'Toggle watched license', value = customhud.vars.togglehud.visibility.license, fgcolor = "200 200 200"}
customhud.uiconfig.togglehud.cargotoggle = iup.stationtoggle { title = 'Toggle cargo', value = customhud.vars.togglehud.visibility.cargo, fgcolor = "200 200 200"}
customhud.uiconfig.togglehud.addonstoggle = iup.stationtoggle { title = 'Toggle addons', value = customhud.vars.togglehud.visibility.addons, fgcolor = "200 200 200"}
customhud.uiconfig.togglehud.distancetoggle = iup.stationtoggle { title = 'Toggle distance', value = customhud.vars.togglehud.visibility.distance, fgcolor = "200 200 200"}
customhud.uiconfig.togglehud.targetinfotoggle = iup.stationtoggle { title = 'Toggle targetinfo', value = customhud.vars.togglehud.visibility.targetinfo, fgcolor = "200 200 200"}
customhud.uiconfig.togglehud.crosshairtoggle = iup.stationtoggle { title = 'Toggle crosshair', value = customhud.vars.togglehud.visibility.crosshair, fgcolor = "200 200 200"}

customhud.uiconfig.togglehud.okbutton = iup.stationbutton { title = "OK" }
customhud.uiconfig.togglehud.cancelbutton = iup.stationbutton { title = "Cancel" }
customhud.uiconfig.togglehud.bindbutton = iup.stationbutton { title = 'Bind' }

customhud.uiconfig.togglehud.bindtext = iup.text { value = '/', size = '40x'}

customhud.uiconfig.togglehud.main = iup.pdarootframe {
	iup.pdasubframebg {
		iup.vbox {
			iup.label { title = '"togglehud" command allows you to toggle chosen elements of normal VO hud with any key.', expand='HORIZONTAL'},
			customhud.uiconfig.togglehud.selfinfotoggle,
			customhud.uiconfig.togglehud.chattoggle,
			customhud.uiconfig.togglehud.missiontimerstoggle,
			customhud.uiconfig.togglehud.licensetoggle,
			customhud.uiconfig.togglehud.cargotoggle,
			customhud.uiconfig.togglehud.addonstoggle,
			customhud.uiconfig.togglehud.distancetoggle,
			customhud.uiconfig.togglehud.targetinfotoggle,
			customhud.uiconfig.togglehud.crosshairtoggle,
			iup.hbox {
			iup.label { title = 'Bind "togglehud" command to this key: ', expand='HORIZONTAL' },
			iup.fill{},
			customhud.uiconfig.togglehud.bindtext,
			customhud.uiconfig.togglehud.bindbutton,
			},
			iup.hbox {
				iup.fill{},
				customhud.uiconfig.togglehud.okbutton,
				customhud.uiconfig.togglehud.cancelbutton,
			}
		}
	}
}

customhud.uiconfig.dialog.togglehud = iup.dialog {
	customhud.uiconfig.togglehud.main,
	BORDER="NO",
    topmost = "YES",
    RESIZE="NO",
    MAXBOX="NO",
    MINBOX="NO",
    MENUBOX="NO",
    MODAL="YES",
	DEFAULTENTER=customhud.uiconfig.togglehud.okbutton,
	DEFAULTESC=customhud.uiconfig.togglehud.cancelbutton,
}


function customhud.uiconfig.togglehud.selfinfotoggle:action(v)
	customhud.vars.togglehud.visibility.selfinfo=customhud.uiconfig.togglehud.selfinfotoggle.VALUE
end
function customhud.uiconfig.togglehud.chattoggle:action(v)
	customhud.vars.togglehud.visibility.chat=customhud.uiconfig.togglehud.chattoggle.VALUE
end
function customhud.uiconfig.togglehud.missiontimerstoggle:action(v)
	customhud.vars.togglehud.visibility.missiontimers=customhud.uiconfig.togglehud.missiontimerstoggle.VALUE
end
function customhud.uiconfig.togglehud.licensetoggle:action(v)
	customhud.vars.togglehud.visibility.license=customhud.uiconfig.togglehud.licensetoggle.VALUE
end
function customhud.uiconfig.togglehud.cargotoggle:action(v)
	customhud.vars.togglehud.visibility.cargo=customhud.uiconfig.togglehud.cargotoggle.VALUE
end
function customhud.uiconfig.togglehud.addonstoggle:action(v)
	customhud.vars.togglehud.visibility.addons=customhud.uiconfig.togglehud.addonstoggle.VALUE
end
function customhud.uiconfig.togglehud.distancetoggle:action(v)
	customhud.vars.togglehud.visibility.distance=customhud.uiconfig.togglehud.distancetoggle.VALUE
end
function customhud.uiconfig.togglehud.targetinfotoggle:action(v)
	customhud.vars.togglehud.visibility.targetinfo=customhud.uiconfig.togglehud.targetinfotoggle.VALUE
end
function customhud.uiconfig.togglehud.crosshairtoggle:action(v)
	customhud.vars.togglehud.visibility.crosshair=customhud.uiconfig.togglehud.crosshairtoggle.VALUE
end

function customhud.uiconfig.togglehud.okbutton:action()
	customhud.uiconfig.dialog.togglehud:hide()
	for key,value in pairs(customhud.vars.togglehud.visibility) do
		gkini.WriteString('customhud', 'togglehud.'..key, customhud.uiconfig.togglehud[key..'toggle'].VALUE)
	end
end

function customhud.uiconfig.togglehud.cancelbutton:action()
	customhud.uiconfig.dialog.togglehud:hide()
end

function customhud.uiconfig.togglehud.bindbutton:action()
	gkinterface.GKProcessCommand('bind '..customhud.uiconfig.togglehud.bindtext.value..' togglehud')
end
